//**************OTA*************
#include <ESP8266WiFi.h>
#include <ESP8266mDNS.h>
#include <WiFiUdp.h>
#include <ArduinoOTA.h>
//******************************

#include <PubSubClient.h>
#include <Wire.h>
#include <Servo.h>



#define STASSID "************"
#define STAPSK  "************"

const char* ssid          = STASSID;
const char* password      = STAPSK;

const char* mqttServer    = "***********"; //broker ip
const int   mqttPort      = 1883;
const char* mqttUser      = "";
const char* mqttPassword  = "";

long TimerCounter = 0;
int servoPin = 14;
WiFiClient espClient;
PubSubClient client(espClient);
Servo Servo1;

void callback(char* topic, byte* payload, unsigned int length) 
{
  Serial.print("Message arrived in topic: ");
  Serial.println(topic);
 
  Serial.print("Message:");
  for (int i = 0; i < length; i++) 
  {
    Serial.print((char)payload[i]);
  }
  if ( payload[0]==0x30)
  {
    Servo1.write(120);
        delay(500);
    Servo1.write(90);
    Serial.print("OPEN");
 
  }
 else if ( payload[0]==0x31)
  {
    Servo1.write(65);
    delay(500);
    Servo1.write(90);
    Serial.print("LOCKED");
  }
  Serial.println();
  Serial.println("-----------------------");
}

void setup() 
{
  Serial.begin(115200);
  Serial.println("Booting");
  Serial.println("Ready");
  Serial.print("IP address: ");
  Servo1.attach(servoPin);
  WiFi.mode(WIFI_STA);
  WiFi.begin(ssid, password);
  Servo1.write(90);
  while (WiFi.status() != WL_CONNECTED) 
  {
    Serial.print(".");
    delay(500);
  }
  
  Serial.println(WiFi.localIP());
  client.setServer(mqttServer, mqttPort);
  client.setCallback(callback);
  pinMode(0, OUTPUT);
  digitalWrite(0,0);
  connect();


  //****************OTA**********************************************************
  ArduinoOTA.setHostname("Taklys_servo");
ArduinoOTA.onStart([]() {
    String type;
    if (ArduinoOTA.getCommand() == U_FLASH) {
      type = "sketch";
    } else { // U_FS
      type = "filesystem";
    }

    // NOTE: if updating FS this would be the place to unmount FS using FS.end()
    Serial.println("Start updating " + type);
  });
  ArduinoOTA.onEnd([]() {
    Serial.println("\nEnd");
  });
  ArduinoOTA.onProgress([](unsigned int progress, unsigned int total) {
    Serial.printf("Progress: %u%%\r", (progress / (total / 100)));
  });
  ArduinoOTA.onError([](ota_error_t error) {
    Serial.printf("Error[%u]: ", error);
    if (error == OTA_AUTH_ERROR) {
      Serial.println("Auth Failed");
    } else if (error == OTA_BEGIN_ERROR) {
      Serial.println("Begin Failed");
    } else if (error == OTA_CONNECT_ERROR) {
      Serial.println("Connect Failed");
    } else if (error == OTA_RECEIVE_ERROR) {
      Serial.println("Receive Failed");
    } else if (error == OTA_END_ERROR) {
      Serial.println("End Failed");
    }
  });
  ArduinoOTA.begin();
  Serial.println("Ready");
  Serial.print("IP address: ");
  Serial.println(WiFi.localIP());
  //*****************************************************************************
  
}

void connect()
{
  while (!client.connected()) 
  {
    Serial.println("Connecting to MQTT...");
    if (client.connect("ESP8266Client", mqttUser, mqttPassword )) 
    {
      Serial.println("connected");  
     // client.publish("ESP8266_01_RELE_3/STATUS","OnLine");
      client.subscribe("ESP8266_01_RELE_4/SET");
    } 
    else 
    {
      Serial.print("failed with state ");
      Serial.print(client.state());
      delay(2000);
    }
  }  
}


void loop() 
{

    //*****************OTA******************
  ArduinoOTA.handle();
  //**************************************

  
  if (!client.connected()) 
  {
    connect();
  }
  client.loop();

}
